﻿using System;
using System.Collections.Generic;

namespace UMK.WzorceOperacyjne
{
    //https://sourcemaking.com/design_patterns/observer/cpp/1

    class PodmiotEventArgs : EventArgs
    {
        public int Wartość;        
    }

    class Podmiot //podmiot, obserwabla
    {
        private int wartość;

        public EventHandler<PodmiotEventArgs> ZmianaWartości = null; //event

        private void powiadom()
        {
            if (ZmianaWartości != null) ZmianaWartości(this, new PodmiotEventArgs() { Wartość = wartość });
        }

        public Podmiot()
        {
            wartość = 0;
        }

        public void ZmieńWartość(int nowaWartość)
        {
            wartość = nowaWartość;
            powiadom();
        }
    }
}