﻿using System;

namespace Obserwator
{
    using UMK.WzorceOperacyjne;

    class Program
    {
        static void Main(string[] args)
        {
            int dzielnik = 3;

            void AktualizujDzielenie(object sender, PodmiotEventArgs e)
            {
                int wartość = e.Wartość / dzielnik;
                Console.WriteLine("{0} / {1} = {2}", e.Wartość, dzielnik, wartość);
            }

            void AktualizujModulo(object sender, PodmiotEventArgs e)
            {
                int wartość = e.Wartość % dzielnik;
                Console.WriteLine("{0} % {1} = {2}", wartość, dzielnik, wartość);
            }

            Podmiot podmiot = new Podmiot();
            podmiot.ZmianaWartości += AktualizujDzielenie;
            podmiot.ZmianaWartości += AktualizujModulo;

            podmiot.ZmieńWartość(9);
            Console.WriteLine();
            podmiot.ZmieńWartość(10);
            Console.WriteLine();

            podmiot.ZmianaWartości -= AktualizujModulo;

            podmiot.ZmieńWartość(2);
            Console.WriteLine();
        }                    
    }
}
